package fips.sim.dig.base;

public class BooleanParameter extends AbstractParameter {

  public BooleanParameter(String name, String description,
                          boolean defaultval, boolean currentval) {
    super(name, description, new Boolean(defaultval), new Boolean(currentval),
          false, false, false);

  }


  public boolean isValidParameter(Object o) {
    if((o==null)||(!(o instanceof Boolean))) return(false);

    return(true);
  }



  public Object parseString(String str) throws IllegalArgumentException {
    //TRACE (".parseString(str=\""+str+"\").");

    str=str.trim();
    if(str.equals("true")) return(new Boolean(true));
    if(str.equals("false")) return(new Boolean(false));

    throw new IllegalArgumentException("Not a boolean: "+str);
  }



  public String toString(Object o) {
    Boolean b=(Boolean)o;

    return(b.toString());
  }


}






