package fips.sim.dig.base;


public class ByteArrayParameter extends AbstractParameter {

  int		minbytes;
  int		maxbytes;


  public ByteArrayParameter(String name, String description,
                            byte defaultval[], byte currentval[], 
                            int minbytes, int maxbytes) {
    super(name, description, defaultval, currentval, false, false, false);

    this.minbytes=minbytes;
    this.maxbytes=maxbytes;
  }


  public boolean isValidParameter(Object o) {
    if((o==null)||(!(o instanceof byte[]))) return(false);

    byte val[]=(byte[])o;
    if((minbytes>=0)&&(val.length<minbytes)) return(false);
    if((maxbytes>=0)&&(val.length>maxbytes)) return(false);

    return(true);
  }


  public Object parseString(String str) throws IllegalArgumentException {
    byte ret[]=fips.util.ByteArrayUtil.parseString(str);

    if((minbytes>=0)&&(ret.length<minbytes)) {
      throw new IllegalArgumentException("Data to short");
    }
    if((maxbytes>=0)&&(ret.length>maxbytes)) {
      throw new IllegalArgumentException("Data to long");
    }

    return(ret);
  }



  public String toString(Object o) {
    StringBuffer sbuf=new StringBuffer();

    byte val[]=(byte[])o;


    for(int i=0; i<val.length; i++) {
      if((i>0)&&((i&1)==0)) {
        if((i&0x1F)==0) sbuf.append('\n');
        else sbuf.append(' ');
      }

      sbuf.append(Character.forDigit((val[i]>>4)&0xF, 16));
      sbuf.append(Character.forDigit(val[i]&0xF, 16));
    }

    return(sbuf.toString());
  }





  public int getMaxBytes() { return(maxbytes); }
  public int getMinBytes() { return(minbytes); }


}






