package fips.sim.dig.base;

public class IntegerParameter extends AbstractParameter {

  int		lowerlim;
  int		upperlim;


  public IntegerParameter(String name, String description,
                          int defaultval, int currentval, 
                          int lowerlim, int upperlim) {
    this(name, description, defaultval, currentval, lowerlim, upperlim,
         false, false, false);
  }

  public IntegerParameter(String name, String description,
                          int defaultval, int currentval,
                          int lowerlim, int upperlim, boolean alterssize,
                          boolean alterspinout, boolean altersparams) {
    super(name, description, new Integer(defaultval), new Integer(currentval),
          alterssize, alterspinout, altersparams);

    this.lowerlim=lowerlim;
    this.upperlim=upperlim;
  }


  public boolean isValidParameter(Object o) {
    if((o==null)||(!(o instanceof Integer))) return(false);

    Integer val=(Integer)o;
    if(val.intValue()<lowerlim) return(false);
    if(val.intValue()>upperlim) return(false);

    return(true);
  }



  public Object parseString(String str) throws IllegalArgumentException {
    //TRACE (".parseString(str=\""+str+"\").");

    str=str.trim();

    return(new Integer(Integer.parseInt(str)));
  }



// format using the timepref list
  public String toString(Object o) {
    Integer val=(Integer)o;

    return(val.toString());
  }


}






