package fips.sim.dig.base;

/** Interface for all adjustable parameters.
 */
public interface Parameter {

  public void addParameterChangeListener(ParameterChangeListener pcl);

  public void removeParameterChangeListener(ParameterChangeListener pcl);

  public String getName();
  public String getDescription();

  public Object getValue();
  public void setValue(Object o) throws IllegalArgumentException;

  public Object getDefaultValue();

  public boolean altersSize();
  public boolean altersPinout();
  public boolean altersParameters();


  public boolean isValidParameter(Object o);
  public Object parseString(String str) throws IllegalArgumentException;

  public String toString(Object o);

  public String toString();

}






