package fips.sim.dig.base;

import java.util.logging.Logger;

public class StringParameter extends AbstractParameter {

  int		maxlen;


  public StringParameter(String name, String description,
                         String defaultval, String currentval, 
                         int maxlen) {
    super(name, description, defaultval, currentval, false, false, false);

    if((maxlen<=0)||((currentval!=null)&&(currentval.length()>maxlen))||
       ((defaultval!=null)&&(defaultval.length()>maxlen))) {
      throw new IllegalArgumentException("Maxlen too short for curr/defaultval");
    }
    this.maxlen=maxlen;
  }


  public boolean isValidParameter(Object o) {
    if((o==null)||(!(o instanceof String))) return(false);

    String str=(String)o;
    return(str.length()<=maxlen);
  }



  public Object parseString(String str) throws IllegalArgumentException {
    Logger.getLogger("digsim.base").fine(".parseString(str=\""+str+"\").");

    if(str.length()>maxlen) throw new IllegalArgumentException("String too long");
    return(str);
  }



  public String toString(Object o) {
    return((String)o);
  }


}






