package fips.sim.dig.comp;

import java.awt.Color;
import java.awt.Graphics;

public class SmallLed extends AbstractComponent {

/** Current pin state.
 */
  int				state;

/** Next state sampled at getNextStep
 */
  int				nextstate;

  Color		border=new java.awt.Color(0xC0C0C0);
  Color		scolors[]={
             Color.black,		// LOW
             Color.red,			// HIGH
             new Color(0xC0C000),	// UNKNOWN
             new Color(0x808080),	// HiZ
             new Color(0x400000),	// WEAK-LOW
             new Color(0xC00000),	// WEAK-HIGH
             new Color(0x34) };	// WEAK-UNKNOWN


  public SmallLed() {
    super(1);
    setSize(new java.awt.Dimension(1, 1));
  }


  public String getComponentName() {
    return("SmallLed");
  }

  public String getDescription() {
    return("Minimum size LED");
  }


  public String getPinDescription(int num) {
    throw new InternalError();
  }


  public int getParameterCount() { return(0); }

  public fips.sim.dig.base.Parameter[] getParameters() {
    return(null);
  }


  public void setParameter(int num, Object val) {
    throw new IllegalArgumentException("Invalid parameter number "+num);
  }





  public void setPin(int num, Pin p) {
    logger.fine(".setPin(num="+num+", pin) on "+getName());
    super.setPin(num, p);

    if(state!=getPinValue(num)) {
      state=getPinValue(num);
      needsupdate=true;
    }
  }




/** Get hints for the max length of the next step
 */
  public long getNextStep() {
    //NEVER (".getNextStep()");

    if(state!=getPinValue(0)) {
      nextstate=getPinValue(0);
      return(0);
    }
    return(Long.MAX_VALUE);
  }




/** Do the following calculation step. If cycles is too big,
 *  IllegalArgumentException is thrown
 */
  public void doStep(long cycles) {
    //NEVER (".doStep("+cycles+").");

    if(nextstate!=state) {
      state=nextstate;
      needsupdate=true;
    }
  }




/** Reset cyclecount, params, etc...
 */
  public void reset() {
    throw new InternalError();
  }



  public void writeState(java.io.ObjectOutputStream oos)
                         throws java.io.IOException {
    oos.write(state);
  }

  public void readState(java.io.ObjectInputStream ois)
                        throws java.io.IOException {
    state=ois.read();

    if((state<0)||(state>Pin.WEAKUNKN)) throw new IllegalArgumentException();

    needsupdate=true;
  }



  public void repaint(Graphics g) {
    if(scale>1) {
      g.setColor(border);
      g.drawRect(offset.x, offset.y, (1<<scale)-1, (1<<scale)-1);
    }
    update(g);
  }


  public void update(Graphics g) {
    g.setColor(scolors[state]);

    if(scale>1) {
      g.fillRect(offset.x+1, offset.y+1, (1<<scale)-2, (1<<scale)-2);
    } else {
      g.fillRect(offset.x, offset.y, (1<<scale), (1<<scale));
    }
    needsupdate=false;
  }




  public void doClick(int x, int y, int button) {
    throw new InternalError();
  }

  public java.awt.Point getPinPos(int num) {
    return(new java.awt.Point(orientation>>1,
                              (orientation==0||orientation==3)?0:1));
  }




// ************************************************************************* //
//
//			Internal Methods				     //
//
// ************************************************************************* //




  public Object clone() {
    SmallLed clone = new SmallLed();

    return(clone);
  }



}



