package fips.sim.dig.edit;

import java.awt.event.ComponentEvent;
import java.util.logging.Logger;


/** Key group for GateSelect is gateselect
 *  Keys:
 *  <Ul><Li>windowwidth:
 *  <Li>windowheight:
 *  <Li>windowx:
 *  <Li>windowy:
 *  </Ul>
 */


public class GateSelect implements java.awt.event.ActionListener,
                                   java.awt.event.ComponentListener {


  javax.swing.JFrame		frame;

/** Window size and position
 */
  java.awt.Rectangle		bounds;


  RCFile			rcfile;

  Logger			logger;

  ParameterGroup		pgroup;


  java.util.ArrayList		listeners;

/** Currently selected component
 */
  fips.sim.dig.base.Component	comp;

/** Hashtable with allready initialized components.
 */
  java.util.Hashtable		comp_hash;


  public GateSelect(RCFile rcfile) {
    this.rcfile=rcfile;

    logger=Logger.getLogger("digsim.edit");

    pgroup=rcfile.getParameterGroup(null).getGroup("gateselect");
    if(pgroup==null) {
      rcfile.getParameterGroup(null).createGroup("gateselect");
      pgroup=rcfile.getParameterGroup(null).getGroup("gateselect");
    }

    frame=new javax.swing.JFrame("Components");

    javax.swing.JTabbedPane tp=new javax.swing.JTabbedPane();    
//    tp.setPreferredSize(size);
    frame.getContentPane().add(tp);


    javax.swing.JLabel lab=new javax.swing.JLabel("Not yet");
    lab.setSize(50, 50);
    tp.add("Selected", lab);


//
// build the menu bar
//

    javax.swing.JMenuBar mb=new javax.swing.JMenuBar();
    javax.swing.JMenu men=new javax.swing.JMenu("File");
    mb.add(men);

    men.add(new javax.swing.JMenuItem("Not yet"));


    GateGroup gategroup=rcfile.getGateGroup(null);

    men=new javax.swing.JMenu("Gates");
    mb.add(men);

    java.util.ArrayList menustack=new java.util.ArrayList();
    Object gates[];
    String path="gatesel_";
    javax.swing.JMenuItem mi;


// now build the menus

    if(gategroup!=null) {
      logger.finer("Getting content for gategroup "+gategroup.getKey());
      gates=gategroup.getContent();
      logger.finer("Content length "+(gates==null?-1:gates.length));

      int pos=0;

      while(gates!=null) {
        if(pos<gates.length) {
        if(gates[pos] instanceof Gate) {
          Gate g=(Gate)gates[pos];
          logger.finer("Adding gate "+g.getClassName()+" with path "+path);

          mi=new javax.swing.JMenuItem(g.getName());
          mi.setActionCommand(path+g.getKey());
          mi.addActionListener(this);
          men.add(mi);
          gates[pos]=null;
          pos++;
        } else {
// ascend
          logger.finer("Using gg "+gates[pos]);
          GateGroup gg=(GateGroup)gates[pos];
          javax.swing.JMenu m;
          m=new javax.swing.JMenu(gg.getName());
          path=path+gg.getKey()+"_";
          men.add(m);
          menustack.add(men);
          menustack.add(gates);
          men=m;
          Object g[]=gg.getContent();
          gates[pos]=null;
          gates=g;
          pos=0;
        }
        }

        while(pos==gates.length) {
          if(menustack.size()==0) {
            logger.finest("Menustack empty.");
            gates=null;
            path=null;
            break;
          } else { // descend
            if(men.getItemCount()==0) {
              men.add(mi=new javax.swing.JMenuItem("Empty"));
              mi.setEnabled(false);
            }

            gates=(Object[])menustack.get(menustack.size()-1);
            men=(javax.swing.JMenu)menustack.get(menustack.size()-2);
            menustack.remove(menustack.size()-1);
            menustack.remove(menustack.size()-1);

            logger.finest("Decreasing current path "+path);
            int i=path.lastIndexOf('_', path.length()-2);
            if(i<0) path="";
            else path=path.substring(0, i+1);

            logger.finest("New path is "+path);
            for(pos=0; pos<gates.length; pos++) {
              if(gates[pos]!=null) break;
            }
          }
        }
      }
    } else {
      //WARNING ("No root gategroup found, configuration error?");
    }


    frame.setJMenuBar(mb);

    bounds=pgroup.getBounds("window");
    if(bounds==null) bounds=new java.awt.Rectangle(0, 0, 300, 250);

//    frame.pack();

    frame.setBounds(bounds);
    frame.setVisible(true);

    frame.addComponentListener(this);


    comp=null;
    listeners=new java.util.ArrayList();

    comp_hash=new java.util.Hashtable();
  }





//
// listener admin
//


  public void addSelectionListener(GateSelectionListener l) {
    logger.fine(".addSelectionListener(l).");
    listeners.add(l);
  }


  public void removeSelectionListener(GateSelectionListener l) {
    logger.fine(".removeSelectionListener(l).");
    if(!listeners.contains(l)) throw new IllegalArgumentException();
    listeners.remove(l);
  }


  public fips.sim.dig.base.Component getSelectedComponent() {
    return(comp);
  }


  private void notifyListeners(fips.sim.dig.base.Component c) {
    //TRACE (".notifyListeners(c).");

    for(int i=0; i<listeners.size(); i++) {
      ((GateSelectionListener)listeners.get(i)).gateSelected(c);
    }
  }
  








//**************************************************************************//
//
//			ActionListener impl				    //
//
//**************************************************************************//



  public void actionPerformed(java.awt.event.ActionEvent ae) {
    String cmd=ae.getActionCommand();
    //TRACE (".actionPerformed(cmd=\""+cmd+"\").");

    if(cmd.startsWith("gatesel_")) {
      String gatekey=cmd.substring(8);

      fips.sim.dig.base.Component c;
      c=(fips.sim.dig.base.Component)comp_hash.get(gatekey);
      if(c==null) {
// get component class from gate list
        GateGroup gategroup=rcfile.getGateGroup(null);
        Gate gate=null;

        while(gate==null) {
          Object gates[]=gategroup.getContent();

          
          for(int i=0; i<gates.length; i++) {
            if(gates[i] instanceof Gate) {
              if(((Gate)gates[i]).getKey().equals(gatekey)) {
                gate=(Gate)gates[i];
                break;
              }
            } else {
              if(gatekey.startsWith(((GateGroup)gates[i]).getKey())) {
                int j=((GateGroup)gates[i]).getKey().length();
                if(gatekey.charAt(j)=='_') {
                  gatekey=gatekey.substring(j+1);
                  gategroup=(GateGroup)gates[i];
                  break;
                }
              }
            }
          }
        }

        //ARM ("#: located gate "+gate.getName());

        try {
          Class cclass=getClass().getClassLoader().
                                  loadClass(gate.getClassName());
          c=(fips.sim.dig.base.Component)cclass.newInstance();
        } catch (Exception e) {
          e.printStackTrace();
          throw new IllegalArgumentException();
        }

        comp_hash.put(cmd.substring(8), c);
      }


      comp=c;
      //ARM ("#: gate "+comp.getName()+" selected.");
      notifyListeners(comp);

      return;
    }



    throw new IllegalArgumentException("Unknown command \""+cmd+"\".");
  }




//**************************************************************************//
//
//			ComponentListener implementation		    //
//
//**************************************************************************//

  public void componentMoved(ComponentEvent ce) {
    logger.finer(".componentMoved(ce)");

    if((frame.getX()!=bounds.x)||(frame.getY()!=bounds.y)) {
      bounds.x=frame.getX();
      bounds.y=frame.getY();
      pgroup.setBounds("window", bounds);
    }
  }

  public void componentResized(ComponentEvent ce) {
    logger.finer(".componentResized(ce)");

    if((frame.getWidth()!=bounds.width)||(frame.getHeight()!=bounds.height)) {
      bounds.height=frame.getHeight();
      bounds.width=frame.getWidth();
      pgroup.setBounds("window", bounds);
    }
  }


  public void componentShown(ComponentEvent ce) {
    //TRACE (".componentShown(ce)");
  }

  public void componentHidden(ComponentEvent ce) {
    //TRACE (".componentHidden(ce)");
  }



}








