package fips.sim.dig.edit;


/** Just a convenient class to for organizing the parameter
 *  groups as seen from the editor side, data filled from
 *  merged rcfiles
 */
public class ParameterGroup {

  RCFile	rcfile;
  String	path[];

  public ParameterGroup(RCFile rcfile, String path[]) {
    this.rcfile=rcfile;
    this.path=path;
  }


  public String getParameter(String param) {
    return(rcfile.getParameter(path, param));
  }

  public void setParameter(String param, String value) {
    rcfile.setParameter(path, param, value);
  }



/** Get a parameter subgroup
 *  @returns null if the group doesn't exist
 */
  public ParameterGroup getGroup(String key) {
    return(rcfile.getParameterGroup(appendPath(key)));
  }


  public void createGroup(String key) {
    rcfile.createParameterGroup(appendPath(key));
  }




//**************************************************************************//
//
//			Convenience Methods
//
//***************************************************************


  public java.awt.Rectangle getBounds(String param) {
    String val=getParameter(param);
    if(val==null) return(null);

    try {
      java.awt.Rectangle bounds=new java.awt.Rectangle();
      int i=val.indexOf(',');
      int j=val.indexOf(',', i+1);
      int k=val.indexOf(',', j+1);

      bounds.x=Integer.parseInt(val.substring(0, i));
      bounds.y=Integer.parseInt(val.substring(i+1, j));
      bounds.width=Integer.parseInt(val.substring(j+1, k));
      bounds.height=Integer.parseInt(val.substring(k+1, val.length()));
      return(bounds);
    } catch (NumberFormatException nfe) {
      //TRACE ("#: failed to parse bounds "+val);
    }

    return(null); 
  }


  public void setBounds(String param, java.awt.Rectangle val) {
    String valstr=val.x+","+val.y+","+val.width+","+val.height;
    setParameter(param, valstr);
  }





  private String[] appendPath(String key) {
    String sp[]=null;
    if(path==null) sp=new String[1];
    else {
      sp=new String[path.length+1];
      System.arraycopy(path, 0, sp, 0, path.length);
    }
    sp[sp.length-1]=key;
    return(sp);
  }



}





