package fips.sim.dig.edit.configure;

import java.util.logging.Logger;

import javax.swing.JComponent;

import fips.sim.dig.base.Parameter;
import fips.sim.dig.base.ParameterChangeListener;

/** This class describes a very simple EditableParameter
 *  implementation that allows the changing of parameters
 *  with simple text representation (single line)
 */
public abstract class AbstractWrappedParameterEditor
                      extends EditableParameter {
  protected Parameter		param;

  protected Logger		logger;

  public AbstractWrappedParameterEditor(Parameter param) {
    super(param.getName(), param.getDescription(),
          param.getValue(), param.getDefaultValue(),
          param.altersSize(), param.altersPinout(), param.altersParameters());

    this.param=param;

    logger=Logger.getLogger("digsim.edit.configure");
  }




  public abstract JComponent getGUI();




//******************************************
//
//			base.Parameter methods
//
//******************************************

  public boolean isValidParameter(Object o) {
    return(param.isValidParameter(o));
  }

  public Object parseString(String str) throws IllegalArgumentException {
    return(param.parseString(str));
  }

  public String toString(Object o) {
    return(param.toString(o));
  }


  public synchronized void setValue(Object o) {
    param.setValue(o);

    super.setValue(o);
  }


}




