package fips.sim.dig.edit.configure;

import java.awt.Color;

import java.util.logging.Logger;

import javax.swing.JComponent;
import javax.swing.JComboBox;

import fips.sim.dig.base.Parameter;
import fips.sim.dig.base.ParameterChangeListener;

/** This class describes a very simple EditableParameter
 *  implementation that allows the changing of parameters
 *  with simple text representation (single line)
 */
public class BooleanParameterEditor extends AbstractWrappedParameterEditor
                                 implements java.awt.event.ItemListener {
  private JComboBox		component;

  public BooleanParameterEditor(Parameter param) {
    super(param);

    if(!(param instanceof fips.sim.dig.base.BooleanParameter)) {
      throw new IllegalArgumentException();
    }
  }


  public synchronized JComponent getGUI() {
    if(component==null) {
      component=new javax.swing.JComboBox();
      component.addItem("True");
      component.addItem("False");
      component.setSelectedIndex(((Boolean)(param.getValue())).booleanValue()?0:1);

      component.addItemListener(this);
    }

    return(component);
  }



  public synchronized void itemStateChanged(java.awt.event.ItemEvent ie) {
    boolean value=component.getSelectedIndex()==0;
    setValue(new Boolean(value));
  }



}




