package fips.sim.dig.edit.configure;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.LineBorder;

import fips.sim.dig.base.ByteArrayParameter;
import fips.sim.dig.base.Parameter;
import fips.sim.dig.base.ParameterChangeListener;

/*
import java.util.logging.Logger;


import fips.sim.dig.base.Component;
import fips.sim.dig.base.StringParameter;

import java.awt.Color;

import java.util.logging.Logger;

import javax.swing.JComponent;
import javax.swing.JTextField;
import javax.swing.event.DocumentListener;

import fips.sim.dig.base.Parameter;
import fips.sim.dig.base.ParameterChangeListener;
*/



/** This class contains a simple editor for ByteArrayParameters
 *  The current content is displayed in a label, a click on it
 *  starts the editor.
 */
public class ByteArrayParameterEditor extends AbstractWrappedParameterEditor
                                      implements ActionListener {

  private JButton		component;

  private JDialog		dialog;
  private JTextArea		dataarea;

  public ByteArrayParameterEditor(Parameter param) {
    super(param);
  }


  public synchronized JComponent getGUI() {
    if(component==null) {
      component=new javax.swing.JButton();

      String str=param.toString();
      if(str.length()>40) str=str.substring(0, 37)+"...";
      component.setText(str);
      component.setActionCommand("edit_button");
      component.addActionListener(this);
    }

    return(component);
  }



  public void actionPerformed(ActionEvent ae) {

    String cmd=ae.getActionCommand();

    if(cmd.equals("edit_button")) {

       setEditing(true);

// create the GUI
      dialog=new JDialog();
      dialog.setModal(true);
      dialog.setTitle("Changing Parameter:"+getName());
      dialog.setSize(new Dimension(500, 300));


      java.awt.GridBagLayout gbl=new java.awt.GridBagLayout();
      dialog.getContentPane().setLayout(gbl);

      java.awt.GridBagConstraints gbc = new java.awt.GridBagConstraints();

      gbc.gridwidth=3;
      gbc.gridheight=1;
      gbc.gridx=0;
      gbc.gridy=0;
      gbc.weightx=1.0;
      gbc.weighty=0.0;
      gbc.fill=gbc.NONE;
      gbc.insets=new java.awt.Insets(16, 1, 16, 1);

      JLabel label=new JLabel("Parameter Info");
      gbl.setConstraints(label, gbc);
      dialog.getContentPane().add(label);

      gbc.gridy++;
      gbc.fill=gbc.BOTH;
      gbc.insets=new java.awt.Insets(2, 2, 2, 2);
      JTextArea description=new JTextArea();
      description.setRows(5);
      description.setColumns(80);
      description.setEditable(false);
      description.setText(getDescription());
      description.setFont(new Font("monospaced", Font.PLAIN, 12));

      JScrollPane dscroll=new JScrollPane();
      dscroll.setHorizontalScrollBarPolicy(dscroll.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      dscroll.setVerticalScrollBarPolicy(dscroll.VERTICAL_SCROLLBAR_AS_NEEDED);
      dscroll.setViewportView(description);

      dscroll.setPreferredSize(description.getPreferredScrollableViewportSize());
      dscroll.setMinimumSize(description.getPreferredScrollableViewportSize());
      gbl.setConstraints(dscroll, gbc);
      dialog.getContentPane().add(dscroll);

      gbc.gridy++;
      gbc.fill=gbc.NONE;
      gbl.setConstraints(label=new JLabel("Value"), gbc);
      dialog.getContentPane().add(label);

      gbc.gridy++;
      gbc.weighty=1.0;
      gbc.fill=gbc.BOTH;
      gbc.anchor=gbc.NORTH;


      JScrollPane scroll=new JScrollPane();
      scroll.setHorizontalScrollBarPolicy(scroll.HORIZONTAL_SCROLLBAR_AS_NEEDED);
      scroll.setVerticalScrollBarPolicy(scroll.VERTICAL_SCROLLBAR_AS_NEEDED);

      javax.swing.JPanel pan=new javax.swing.JPanel();
      scroll.setViewportView(pan);

      JTextArea offsetarea=new JTextArea("", 20, 6);
      offsetarea.setEditable(false);
      offsetarea.setFont(new Font("monospaced", Font.PLAIN, 12));
      pan.add(offsetarea); 

      dataarea=new JTextArea("", 20, 80);
      dataarea.setFont(new Font("monospaced", Font.PLAIN, 12));
      pan.add(dataarea); 


      ByteArrayParameter bap=(ByteArrayParameter)param;

      StringBuffer sbuf=new StringBuffer();
      int maxrows=(bap.getMaxBytes()+31)>>5;
      for(int i=0; i<maxrows; i++) {
        if(i>0) sbuf.append('\n');
        sbuf.append(Integer.toHexString(i<<5));
      }

      offsetarea.setText(sbuf.toString());

      dataarea.setText(param.toString());

      gbl.setConstraints(scroll, gbc);
      dialog.getContentPane().add(scroll);


// add the buttons
      javax.swing.JPanel panel=new javax.swing.JPanel();
      panel.setLayout(new java.awt.FlowLayout());

      javax.swing.JButton button=new javax.swing.JButton("Ok");
      button.setActionCommand("ok");
      button.addActionListener(this);
      panel.add(button);

      button=new javax.swing.JButton("Cancel");
      button.setActionCommand("cancel");
      button.addActionListener(this);
      panel.add(button);

    
      gbc.gridy++;
      gbc.weighty=0.0;
      gbc.fill=gbc.BOTH;
      gbl.setConstraints(panel, gbc);
      dialog.getContentPane().add(panel);

      dialog.pack();
      dialog.setVisible(true);

      return;
    }

    if(cmd.equals("ok")) {
// try to parse textare content

      try {
        Object o = parseString(dataarea.getText());
        setValue(o);
      } catch (IllegalArgumentException ia) {
        dataarea.setBorder(new LineBorder(java.awt.Color.red));
        return;
      }


      setEditing(false);
      dialog.setVisible(false);
      return;
    }

    if(cmd.equals("cancel")) {
      setEditing(false);
      dialog.setVisible(false);
      return;
    }

    //ERROR ("#: unknown comand "+cmd);
  }
}















